diff --git a/configure.ac b/configure.ac
index 01b3bbc1be8..32fae8081ef 100644
--- a/configure.ac
+++ b/configure.ac
@@ -38,8 +38,8 @@ AC_DEFINE_UNQUOTED(PG_MAJORVERSION_NUM, $PG_MAJORVERSION, [PostgreSQL major vers
 AC_DEFINE_UNQUOTED(PG_MINORVERSION_NUM, $PG_MINORVERSION, [PostgreSQL minor version number])
 
 PGAC_ARG_REQ(with, extra-version, [STRING], [append STRING to version],
-             [PG_VERSION="$PACKAGE_VERSION$withval"],
-             [PG_VERSION="$PACKAGE_VERSION"])
+						 [PG_VERSION="$PACKAGE_VERSION$withval"],
+						 [PG_VERSION="$PACKAGE_VERSION"])
 AC_DEFINE_UNQUOTED(PG_VERSION, "$PG_VERSION", [PostgreSQL version as a string])
 
 AC_CANONICAL_HOST
@@ -49,33 +49,33 @@ AC_MSG_CHECKING([which template to use])
 
 PGAC_ARG_REQ(with, template, [NAME], [override operating system template],
 [
-  case $withval in
-    list)   echo; ls "$srcdir/src/template"; exit;;
-    *)      if test -f "$srcdir/src/template/$with_template" ; then
-              template=$withval
-            else
-              AC_MSG_ERROR(['$withval' is not a valid template name. Use 'list' for a list.])
-            fi;;
-  esac
+	case $withval in
+		list)   echo; ls "$srcdir/src/template"; exit;;
+		*)      if test -f "$srcdir/src/template/$with_template" ; then
+							template=$withval
+						else
+							AC_MSG_ERROR(['$withval' is not a valid template name. Use 'list' for a list.])
+						fi;;
+	esac
 ],
 [
 # --with-template not given
 
 case $host_os in
-  cygwin*|msys*) template=cygwin ;;
-  darwin*) template=darwin ;;
+	cygwin*|msys*) template=cygwin ;;
+	darwin*) template=darwin ;;
 dragonfly*) template=netbsd ;;
  freebsd*) template=freebsd ;;
  linux*|gnu*|k*bsd*-gnu)
-           template=linux ;;
-   mingw*) template=win32 ;;
-  netbsd*) template=netbsd ;;
+					 template=linux ;;
+	 mingw*) template=win32 ;;
+	netbsd*) template=netbsd ;;
  openbsd*) template=openbsd ;;
  solaris*) template=solaris ;;
 esac
 
-  if test x"$template" = x"" ; then
-    AC_MSG_ERROR([[
+	if test x"$template" = x"" ; then
+		AC_MSG_ERROR([[
 *******************************************************************
 PostgreSQL has apparently not been ported to your platform yet.
 To try a manual configuration, look into the src/template directory
@@ -86,7 +86,7 @@ rectifying this.  Include the above 'checking host system type...'
 line.
 *******************************************************************
 ]])
-  fi
+	fi
 
 ])
 
@@ -114,10 +114,10 @@ PGAC_ARG_REQ(with, includes, [DIRS], [look for additional header files in DIRS])
 # Add non-standard directories to the library search path
 #
 PGAC_ARG_REQ(with, libraries, [DIRS], [look for additional libraries in DIRS],
-             [LIBRARY_DIRS=$withval])
+						 [LIBRARY_DIRS=$withval])
 
 PGAC_ARG_REQ(with, libs,      [DIRS], [alternative spelling of --with-libraries],
-             [LIBRARY_DIRS=$withval])
+						 [LIBRARY_DIRS=$withval])
 
 
 #
@@ -126,8 +126,8 @@ PGAC_ARG_REQ(with, libs,      [DIRS], [alternative spelling of --with-libraries]
 # "--enable-integer-datetimes" switch.
 #
 PGAC_ARG_BOOL(enable, integer-datetimes, yes, [obsolete option, no longer supported],
-              [],
-              [AC_MSG_ERROR([--disable-integer-datetimes is no longer supported])])
+							[],
+							[AC_MSG_ERROR([--disable-integer-datetimes is no longer supported])])
 
 
 #
@@ -135,11 +135,11 @@ PGAC_ARG_BOOL(enable, integer-datetimes, yes, [obsolete option, no longer suppor
 #
 AC_MSG_CHECKING([whether NLS is wanted])
 PGAC_ARG_OPTARG(enable, nls,
-                [LANGUAGES], [enable Native Language Support],
-                [],
-                [WANTED_LANGUAGES=$enableval],
-                [AC_DEFINE(ENABLE_NLS, 1,
-                           [Define to 1 if you want National Language Support. (--enable-nls)])])
+								[LANGUAGES], [enable Native Language Support],
+								[],
+								[WANTED_LANGUAGES=$enableval],
+								[AC_DEFINE(ENABLE_NLS, 1,
+													 [Define to 1 if you want National Language Support. (--enable-nls)])])
 AC_MSG_RESULT([$enable_nls])
 AC_SUBST(enable_nls)
 AC_SUBST(WANTED_LANGUAGES)
@@ -149,8 +149,8 @@ AC_SUBST(WANTED_LANGUAGES)
 #
 AC_MSG_CHECKING([for default port number])
 PGAC_ARG_REQ(with, pgport, [PORTNUM], [set default port number [5432]],
-             [default_port=$withval],
-             [default_port=5432])
+						 [default_port=$withval],
+						 [default_port=5432])
 AC_MSG_RESULT([$default_port])
 # Need both of these because some places want an integer and some a string
 AC_DEFINE_UNQUOTED(DEF_PGPORT, ${default_port},
@@ -159,56 +159,56 @@ to which clients will try to connect.  This can be overridden at run-time,
 but it's convenient if your clients have the right default compiled in.
 (--with-pgport=PORTNUM)])
 AC_DEFINE_UNQUOTED(DEF_PGPORT_STR, "${default_port}",
-                   [Define to the default TCP port number as a string constant.])
+									 [Define to the default TCP port number as a string constant.])
 AC_SUBST(default_port)
 
 # It's worth validating port; you can get very confusing errors otherwise
 if test x"$default_port" = x""; then
-  AC_MSG_ERROR([invalid --with-pgport specification: empty string])
+	AC_MSG_ERROR([invalid --with-pgport specification: empty string])
 elif test ! x`echo "$default_port" | sed -e 's/[[0-9]]*//'` = x""; then
-  AC_MSG_ERROR([invalid --with-pgport specification: must be a number])
+	AC_MSG_ERROR([invalid --with-pgport specification: must be a number])
 elif test ! x`echo "$default_port" | sed -e 's/^0.//'` = x"$default_port"; then
-  AC_MSG_ERROR([invalid --with-pgport specification: must not have leading 0])
+	AC_MSG_ERROR([invalid --with-pgport specification: must not have leading 0])
 elif test "$default_port" -lt "1" -o "$default_port" -gt "65535"; then
-  AC_MSG_ERROR([invalid --with-pgport specification: must be between 1 and 65535])
+	AC_MSG_ERROR([invalid --with-pgport specification: must be between 1 and 65535])
 fi
 
 #
 # '-rpath'-like feature can be disabled
 #
 PGAC_ARG_BOOL(enable, rpath, yes,
-              [do not embed shared library search path in executables])
+							[do not embed shared library search path in executables])
 AC_SUBST(enable_rpath)
 
 #
 # --enable-debug adds -g to compiler flags
 #
 PGAC_ARG_BOOL(enable, debug, no,
-              [build with debugging symbols (-g)])
+							[build with debugging symbols (-g)])
 AC_SUBST(enable_debug)
 
 #
 # --enable-profiling enables gcc profiling
 #
 PGAC_ARG_BOOL(enable, profiling, no,
-              [build with profiling enabled ])
+							[build with profiling enabled ])
 
 #
 # --enable-coverage enables generation of code coverage metrics with gcov
 #
 PGAC_ARG_BOOL(enable, coverage, no,
-              [build with coverage testing instrumentation],
+							[build with coverage testing instrumentation],
 [PGAC_PATH_PROGS(GCOV, gcov)
 if test -z "$GCOV"; then
-  AC_MSG_ERROR([gcov not found])
+	AC_MSG_ERROR([gcov not found])
 fi
 PGAC_PATH_PROGS(LCOV, lcov)
 if test -z "$LCOV"; then
-  AC_MSG_ERROR([lcov not found])
+	AC_MSG_ERROR([lcov not found])
 fi
 PGAC_PATH_PROGS(GENHTML, genhtml)
 if test -z "$GENHTML"; then
-  AC_MSG_ERROR([genhtml not found])
+	AC_MSG_ERROR([genhtml not found])
 fi])
 AC_SUBST(enable_coverage)
 
@@ -216,10 +216,10 @@ AC_SUBST(enable_coverage)
 # DTrace
 #
 PGAC_ARG_BOOL(enable, dtrace, no,
-              [build with DTrace support],
+							[build with DTrace support],
 [PGAC_PATH_PROGS(DTRACE, dtrace)
 if test -z "$DTRACE"; then
-  AC_MSG_ERROR([dtrace not found])
+	AC_MSG_ERROR([dtrace not found])
 fi
 AC_SUBST(DTRACEFLAGS)])
 AC_SUBST(enable_dtrace)
@@ -228,16 +228,16 @@ AC_SUBST(enable_dtrace)
 # TAP tests
 #
 PGAC_ARG_BOOL(enable, tap-tests, no,
-              [enable TAP tests (requires Perl and IPC::Run)])
+							[enable TAP tests (requires Perl and IPC::Run)])
 AC_SUBST(enable_tap_tests)
 AC_ARG_VAR(PG_TEST_EXTRA,
-           [enable selected extra tests (overridden at runtime by PG_TEST_EXTRA environment variable)])
+					 [enable selected extra tests (overridden at runtime by PG_TEST_EXTRA environment variable)])
 
 #
 # Injection points
 #
 PGAC_ARG_BOOL(enable, injection-points, no, [enable injection points (for testing)],
-              [AC_DEFINE([USE_INJECTION_POINTS], 1, [Define to 1 to build with injection points. (--enable-injection-points)])])
+							[AC_DEFINE([USE_INJECTION_POINTS], 1, [Define to 1 to build with injection points. (--enable-injection-points)])])
 AC_SUBST(enable_injection_points)
 
 #
@@ -245,16 +245,16 @@ AC_SUBST(enable_injection_points)
 #
 AC_MSG_CHECKING([for block size])
 PGAC_ARG_REQ(with, blocksize, [BLOCKSIZE], [set table block size in kB [8]],
-             [blocksize=$withval],
-             [blocksize=8])
+						 [blocksize=$withval],
+						 [blocksize=8])
 case ${blocksize} in
-  1) BLCKSZ=1024;;
-  2) BLCKSZ=2048;;
-  4) BLCKSZ=4096;;
-  8) BLCKSZ=8192;;
+	1) BLCKSZ=1024;;
+	2) BLCKSZ=2048;;
+	4) BLCKSZ=4096;;
+	8) BLCKSZ=8192;;
  16) BLCKSZ=16384;;
  32) BLCKSZ=32768;;
-  *) AC_MSG_ERROR([Invalid block size. Allowed values are 1,2,4,8,16,32.])
+	*) AC_MSG_ERROR([Invalid block size. Allowed values are 1,2,4,8,16,32.])
 esac
 AC_MSG_RESULT([${blocksize}kB])
 
@@ -276,29 +276,29 @@ AC_DEFINE_UNQUOTED([BLCKSZ], ${BLCKSZ}, [
 # Relation segment size
 #
 PGAC_ARG_REQ(with, segsize, [SEGSIZE], [set table segment size in GB [1]],
-             [segsize=$withval],
-             [segsize=1])
+						 [segsize=$withval],
+						 [segsize=1])
 PGAC_ARG_REQ(with, segsize-blocks, [SEGSIZE_BLOCKS], [set table segment size in blocks [0]],
-             [segsize_blocks=$withval],
-             [segsize_blocks=0])
+						 [segsize_blocks=$withval],
+						 [segsize_blocks=0])
 
 # If --with-segsize-blocks is non-zero, it is used, --with-segsize
 # otherwise. segsize-blocks is only really useful for developers wanting to
 # test segment related code. Warn if both are used.
 if test $segsize_blocks -ne 0 -a $segsize -ne 1; then
-  AC_MSG_WARN([both --with-segsize and --with-segsize-blocks specified, --with-segsize-blocks wins])
+	AC_MSG_WARN([both --with-segsize and --with-segsize-blocks specified, --with-segsize-blocks wins])
 fi
 
 AC_MSG_CHECKING([for segment size])
 if test $segsize_blocks -eq 0; then
-  # this expression is set up to avoid unnecessary integer overflow
-  # blocksize is already guaranteed to be a factor of 1024
-  RELSEG_SIZE=`expr '(' 1024 / ${blocksize} ')' '*' ${segsize} '*' 1024`
-  test $? -eq 0 || exit 1
-  AC_MSG_RESULT([${segsize}GB])
+	# this expression is set up to avoid unnecessary integer overflow
+	# blocksize is already guaranteed to be a factor of 1024
+	RELSEG_SIZE=`expr '(' 1024 / ${blocksize} ')' '*' ${segsize} '*' 1024`
+	test $? -eq 0 || exit 1
+	AC_MSG_RESULT([${segsize}GB])
 else
-  RELSEG_SIZE=$segsize_blocks
-  AC_MSG_RESULT([${RELSEG_SIZE} blocks])
+	RELSEG_SIZE=$segsize_blocks
+	AC_MSG_RESULT([${RELSEG_SIZE} blocks])
 fi
 
 AC_DEFINE_UNQUOTED([RELSEG_SIZE], ${RELSEG_SIZE}, [
@@ -325,17 +325,17 @@ AC_DEFINE_UNQUOTED([RELSEG_SIZE], ${RELSEG_SIZE}, [
 #
 AC_MSG_CHECKING([for WAL block size])
 PGAC_ARG_REQ(with, wal-blocksize, [BLOCKSIZE], [set WAL block size in kB [8]],
-             [wal_blocksize=$withval],
-             [wal_blocksize=8])
+						 [wal_blocksize=$withval],
+						 [wal_blocksize=8])
 case ${wal_blocksize} in
-  1) XLOG_BLCKSZ=1024;;
-  2) XLOG_BLCKSZ=2048;;
-  4) XLOG_BLCKSZ=4096;;
-  8) XLOG_BLCKSZ=8192;;
+	1) XLOG_BLCKSZ=1024;;
+	2) XLOG_BLCKSZ=2048;;
+	4) XLOG_BLCKSZ=4096;;
+	8) XLOG_BLCKSZ=8192;;
  16) XLOG_BLCKSZ=16384;;
  32) XLOG_BLCKSZ=32768;;
  64) XLOG_BLCKSZ=65536;;
-  *) AC_MSG_ERROR([Invalid WAL block size. Allowed values are 1,2,4,8,16,32,64.])
+	*) AC_MSG_ERROR([Invalid WAL block size. Allowed values are 1,2,4,8,16,32,64.])
 esac
 AC_MSG_RESULT([${wal_blocksize}kB])
 
@@ -366,22 +366,22 @@ AC_CACHE_VAL([pgac_cv_prog_cc_c11],
 [pgac_cv_prog_cc_c11=no
 pgac_save_CC=$CC
 for pgac_arg in '' '-std=gnu11' '-std=c11'; do
-  CC="$pgac_save_CC $pgac_arg"
-  AC_COMPILE_IFELSE([AC_LANG_SOURCE([[#if !defined __STDC_VERSION__ || __STDC_VERSION__ < 201112L
+	CC="$pgac_save_CC $pgac_arg"
+	AC_COMPILE_IFELSE([AC_LANG_SOURCE([[#if !defined __STDC_VERSION__ || __STDC_VERSION__ < 201112L
 # error "Compiler does not advertise C11 conformance"
 #endif]])], [[pgac_cv_prog_cc_c11=$pgac_arg]])
-  test x"$pgac_cv_prog_cc_c11" != x"no" && break
+	test x"$pgac_cv_prog_cc_c11" != x"no" && break
 done
 CC=$pgac_save_CC])
 
 if test x"$pgac_cv_prog_cc_c11" = x"no"; then
-  AC_MSG_RESULT([unsupported])
-  AC_MSG_ERROR([C compiler "$CC" does not support C11])
+	AC_MSG_RESULT([unsupported])
+	AC_MSG_ERROR([C compiler "$CC" does not support C11])
 elif test x"$pgac_cv_prog_cc_c11" = x""; then
-  AC_MSG_RESULT([none needed])
+	AC_MSG_RESULT([none needed])
 else
-  AC_MSG_RESULT([$pgac_cv_prog_cc_c11])
-  CC="$CC $pgac_cv_prog_cc_c11"
+	AC_MSG_RESULT([$pgac_cv_prog_cc_c11])
+	CC="$CC $pgac_cv_prog_cc_c11"
 fi
 
 
@@ -400,11 +400,11 @@ choke me
 #
 # Checked early because subsequent tests depend on it.
 PGAC_ARG_BOOL(with, llvm, no, [build with LLVM based JIT support],
-              [AC_DEFINE([USE_LLVM], 1, [Define to 1 to build with LLVM based JIT support. (--with-llvm)])])
+							[AC_DEFINE([USE_LLVM], 1, [Define to 1 to build with LLVM based JIT support. (--with-llvm)])])
 AC_SUBST(with_llvm)
 dnl must use AS_IF here, else AC_REQUIRES inside PGAC_LLVM_SUPPORT malfunctions
 AS_IF([test "$with_llvm" = yes], [
-  PGAC_LLVM_SUPPORT()
+	PGAC_LLVM_SUPPORT()
 ]) # fi
 
 
@@ -424,33 +424,33 @@ unset CXXFLAGS
 # else:  If the compiler is something else, then we use -O, unless debugging.
 
 if test "$ac_env_CFLAGS_set" = set; then
-  CFLAGS=$ac_env_CFLAGS_value
+	CFLAGS=$ac_env_CFLAGS_value
 elif test "${CFLAGS+set}" = set; then
-  : # (keep what template set)
+	: # (keep what template set)
 elif test "$enable_coverage" = yes; then
-  : # no optimization by default
+	: # no optimization by default
 elif test "$GCC" = yes; then
-  CFLAGS="-O2"
+	CFLAGS="-O2"
 else
-  # if the user selected debug mode, don't use -O
-  if test "$enable_debug" != yes; then
-    CFLAGS="-O"
-  fi
+	# if the user selected debug mode, don't use -O
+	if test "$enable_debug" != yes; then
+		CFLAGS="-O"
+	fi
 fi
 
 if test "$ac_env_CXXFLAGS_set" = set; then
-  CXXFLAGS=$ac_env_CXXFLAGS_value
+	CXXFLAGS=$ac_env_CXXFLAGS_value
 elif test "${CXXFLAGS+set}" = set; then
-  : # (keep what template set)
+	: # (keep what template set)
 elif test "$enable_coverage" = yes; then
-  : # no optimization by default
+	: # no optimization by default
 elif test "$GCC" = yes; then
-  CXXFLAGS="-O2"
+	CXXFLAGS="-O2"
 else
-  # if the user selected debug mode, don't use -O
-  if test "$enable_debug" != yes; then
-    CXXFLAGS="-O"
-  fi
+	# if the user selected debug mode, don't use -O
+	if test "$enable_debug" != yes; then
+		CXXFLAGS="-O"
+	fi
 fi
 
 # When generating bitcode (for inlining) we always want to use -O2
@@ -460,14 +460,14 @@ fi
 # attributes everywhere), which is bad for testing.  Still allow the
 # environment to override if done explicitly.
 if test "$ac_env_BITCODE_CFLAGS_set" = set; then
-  BITCODE_CFLAGS=$ac_env_BITCODE_CFLAGS_value
+	BITCODE_CFLAGS=$ac_env_BITCODE_CFLAGS_value
 else
-  BITCODE_CFLAGS="-O2 $BITCODE_CFLAGS"
+	BITCODE_CFLAGS="-O2 $BITCODE_CFLAGS"
 fi
 if test "$ac_env_BITCODE_CXXFLAGS_set" = set; then
-  BITCODE_CXXFLAGS=$ac_env_BITCODE_CXXFLAGS_value
+	BITCODE_CXXFLAGS=$ac_env_BITCODE_CXXFLAGS_value
 else
-  BITCODE_CXXFLAGS="-O2 $BITCODE_CXXFLAGS"
+	BITCODE_CXXFLAGS="-O2 $BITCODE_CXXFLAGS"
 fi
 
 # C[XX]FLAGS we determined above will be added back at the end
@@ -482,10 +482,10 @@ BITCODE_CXXFLAGS=""
 
 # set CFLAGS_UNROLL_LOOPS and CFLAGS_VECTORIZE from the environment, if present
 if test "$ac_env_CFLAGS_UNROLL_LOOPS_set" = set; then
-  CFLAGS_UNROLL_LOOPS=$ac_env_CFLAGS_UNROLL_LOOPS_value
+	CFLAGS_UNROLL_LOOPS=$ac_env_CFLAGS_UNROLL_LOOPS_value
 fi
 if test "$ac_env_CFLAGS_VECTORIZE_set" = set; then
-  CFLAGS_VECTORIZE=$ac_env_CFLAGS_VECTORIZE_value
+	CFLAGS_VECTORIZE=$ac_env_CFLAGS_VECTORIZE_value
 fi
 
 # Some versions of GCC support some additional useful warning flags.
@@ -494,104 +494,104 @@ fi
 # but has its own.  Also check other compiler-specific flags here.
 
 if test "$GCC" = yes -a "$ICC" = no; then
-  CFLAGS="-Wall -Wmissing-prototypes -Wpointer-arith"
-  CXXFLAGS="-Wall -Wpointer-arith"
-  # These work in some but not all gcc versions
-  save_CFLAGS=$CFLAGS
-  PGAC_PROG_CC_CFLAGS_OPT([-Wdeclaration-after-statement])
-  # -Wdeclaration-after-statement isn't applicable for C++.  Specific C files
-  # disable it, so AC_SUBST the negative form.
-  PERMIT_DECLARATION_AFTER_STATEMENT=
-  if test x"$save_CFLAGS" != x"$CFLAGS"; then
-    PERMIT_DECLARATION_AFTER_STATEMENT=-Wno-declaration-after-statement
-  fi
-  AC_SUBST(PERMIT_DECLARATION_AFTER_STATEMENT)
-  # Really don't want VLAs to be used in our dialect of C
-  PGAC_PROG_CC_CFLAGS_OPT([-Werror=vla])
-  # On macOS, complain about usage of symbols newer than the deployment target
-  PGAC_PROG_CC_CFLAGS_OPT([-Werror=unguarded-availability-new])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Werror=unguarded-availability-new])
-  # -Wvla is not applicable for C++
-  PGAC_PROG_CC_CFLAGS_OPT([-Wendif-labels])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Wendif-labels])
-  PGAC_PROG_CC_CFLAGS_OPT([-Wmissing-format-attribute])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Wmissing-format-attribute])
-  PGAC_PROG_CC_CFLAGS_OPT([-Wimplicit-fallthrough=3])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Wimplicit-fallthrough=3])
-  PGAC_PROG_CC_CFLAGS_OPT([-Wcast-function-type])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Wcast-function-type])
-  PGAC_PROG_CC_CFLAGS_OPT([-Wshadow=compatible-local])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Wshadow=compatible-local])
-  # This was included in -Wall/-Wformat in older GCC versions
-  PGAC_PROG_CC_CFLAGS_OPT([-Wformat-security])
-  PGAC_PROG_CXX_CFLAGS_OPT([-Wformat-security])
-  # gcc 14+, clang for a while
-  # (Supported in C++ by clang but not gcc.  For consistency, omit in C++.)
-  save_CFLAGS=$CFLAGS
-  PGAC_PROG_CC_CFLAGS_OPT([-Wmissing-variable-declarations])
-  PERMIT_MISSING_VARIABLE_DECLARATIONS=
-  if test x"$save_CFLAGS" != x"$CFLAGS"; then
-    PERMIT_MISSING_VARIABLE_DECLARATIONS=-Wno-missing-variable-declarations
-  fi
-  AC_SUBST(PERMIT_MISSING_VARIABLE_DECLARATIONS)
-  # Disable strict-aliasing rules; needed for gcc 3.3+
-  PGAC_PROG_CC_CFLAGS_OPT([-fno-strict-aliasing])
-  PGAC_PROG_CXX_CFLAGS_OPT([-fno-strict-aliasing])
-  # Disable optimizations that assume no overflow; needed for gcc 4.3+
-  PGAC_PROG_CC_CFLAGS_OPT([-fwrapv])
-  PGAC_PROG_CXX_CFLAGS_OPT([-fwrapv])
-  # Disable FP optimizations that cause various errors on gcc 4.5+ or maybe 4.6+
-  PGAC_PROG_CC_CFLAGS_OPT([-fexcess-precision=standard])
-  PGAC_PROG_CXX_CFLAGS_OPT([-fexcess-precision=standard])
-  # Optimization flags for specific files that benefit from loop unrolling
-  PGAC_PROG_CC_VAR_OPT(CFLAGS_UNROLL_LOOPS, [-funroll-loops])
-  # Optimization flags for specific files that benefit from vectorization
-  PGAC_PROG_CC_VAR_OPT(CFLAGS_VECTORIZE, [-ftree-vectorize])
-  #
-  # The following tests want to suppress various unhelpful warnings by adding
-  # -Wno-foo switches.  But gcc won't complain about unrecognized -Wno-foo
-  # switches, so we have to test for the positive form and if that works,
-  # add the negative form.  Note that tests of this form typically need to
-  # be duplicated in the BITCODE_CFLAGS setup stanza below.
-  #
-  # Suppress clang's unhelpful unused-command-line-argument warnings.
-  NOT_THE_CFLAGS=""
-  PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wunused-command-line-argument])
-  if test -n "$NOT_THE_CFLAGS"; then
-    CFLAGS="$CFLAGS -Wno-unused-command-line-argument"
-  fi
-  # Remove clang 12+'s compound-token-split-by-macro, as this causes a lot
-  # of warnings when building plperl because of usages in the Perl headers.
-  NOT_THE_CFLAGS=""
-  PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wcompound-token-split-by-macro])
-  if test -n "$NOT_THE_CFLAGS"; then
-    CFLAGS="$CFLAGS -Wno-compound-token-split-by-macro"
-  fi
-  # Similarly disable useless truncation warnings from gcc 8+
-  NOT_THE_CFLAGS=""
-  PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wformat-truncation])
-  if test -n "$NOT_THE_CFLAGS"; then
-    CFLAGS="$CFLAGS -Wno-format-truncation"
-  fi
-  NOT_THE_CFLAGS=""
-  PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wstringop-truncation])
-  if test -n "$NOT_THE_CFLAGS"; then
-    CFLAGS="$CFLAGS -Wno-stringop-truncation"
-  fi
-  # Suppress clang 16's strict warnings about function casts
-  NOT_THE_CFLAGS=""
-  PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wcast-function-type-strict])
-  if test -n "$NOT_THE_CFLAGS"; then
-    CFLAGS="$CFLAGS -Wno-cast-function-type-strict"
-  fi
+	CFLAGS="-Wall -Wmissing-prototypes -Wpointer-arith"
+	CXXFLAGS="-Wall -Wpointer-arith"
+	# These work in some but not all gcc versions
+	save_CFLAGS=$CFLAGS
+	PGAC_PROG_CC_CFLAGS_OPT([-Wdeclaration-after-statement])
+	# -Wdeclaration-after-statement isn't applicable for C++.  Specific C files
+	# disable it, so AC_SUBST the negative form.
+	PERMIT_DECLARATION_AFTER_STATEMENT=
+	if test x"$save_CFLAGS" != x"$CFLAGS"; then
+		PERMIT_DECLARATION_AFTER_STATEMENT=-Wno-declaration-after-statement
+	fi
+	AC_SUBST(PERMIT_DECLARATION_AFTER_STATEMENT)
+	# Really don't want VLAs to be used in our dialect of C
+	PGAC_PROG_CC_CFLAGS_OPT([-Werror=vla])
+	# On macOS, complain about usage of symbols newer than the deployment target
+	PGAC_PROG_CC_CFLAGS_OPT([-Werror=unguarded-availability-new])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Werror=unguarded-availability-new])
+	# -Wvla is not applicable for C++
+	PGAC_PROG_CC_CFLAGS_OPT([-Wendif-labels])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Wendif-labels])
+	PGAC_PROG_CC_CFLAGS_OPT([-Wmissing-format-attribute])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Wmissing-format-attribute])
+	PGAC_PROG_CC_CFLAGS_OPT([-Wimplicit-fallthrough=3])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Wimplicit-fallthrough=3])
+	PGAC_PROG_CC_CFLAGS_OPT([-Wcast-function-type])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Wcast-function-type])
+	PGAC_PROG_CC_CFLAGS_OPT([-Wshadow=compatible-local])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Wshadow=compatible-local])
+	# This was included in -Wall/-Wformat in older GCC versions
+	PGAC_PROG_CC_CFLAGS_OPT([-Wformat-security])
+	PGAC_PROG_CXX_CFLAGS_OPT([-Wformat-security])
+	# gcc 14+, clang for a while
+	# (Supported in C++ by clang but not gcc.  For consistency, omit in C++.)
+	save_CFLAGS=$CFLAGS
+	PGAC_PROG_CC_CFLAGS_OPT([-Wmissing-variable-declarations])
+	PERMIT_MISSING_VARIABLE_DECLARATIONS=
+	if test x"$save_CFLAGS" != x"$CFLAGS"; then
+		PERMIT_MISSING_VARIABLE_DECLARATIONS=-Wno-missing-variable-declarations
+	fi
+	AC_SUBST(PERMIT_MISSING_VARIABLE_DECLARATIONS)
+	# Disable strict-aliasing rules; needed for gcc 3.3+
+	PGAC_PROG_CC_CFLAGS_OPT([-fno-strict-aliasing])
+	PGAC_PROG_CXX_CFLAGS_OPT([-fno-strict-aliasing])
+	# Disable optimizations that assume no overflow; needed for gcc 4.3+
+	PGAC_PROG_CC_CFLAGS_OPT([-fwrapv])
+	PGAC_PROG_CXX_CFLAGS_OPT([-fwrapv])
+	# Disable FP optimizations that cause various errors on gcc 4.5+ or maybe 4.6+
+	PGAC_PROG_CC_CFLAGS_OPT([-fexcess-precision=standard])
+	PGAC_PROG_CXX_CFLAGS_OPT([-fexcess-precision=standard])
+	# Optimization flags for specific files that benefit from loop unrolling
+	PGAC_PROG_CC_VAR_OPT(CFLAGS_UNROLL_LOOPS, [-funroll-loops])
+	# Optimization flags for specific files that benefit from vectorization
+	PGAC_PROG_CC_VAR_OPT(CFLAGS_VECTORIZE, [-ftree-vectorize])
+	#
+	# The following tests want to suppress various unhelpful warnings by adding
+	# -Wno-foo switches.  But gcc won't complain about unrecognized -Wno-foo
+	# switches, so we have to test for the positive form and if that works,
+	# add the negative form.  Note that tests of this form typically need to
+	# be duplicated in the BITCODE_CFLAGS setup stanza below.
+	#
+	# Suppress clang's unhelpful unused-command-line-argument warnings.
+	NOT_THE_CFLAGS=""
+	PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wunused-command-line-argument])
+	if test -n "$NOT_THE_CFLAGS"; then
+		CFLAGS="$CFLAGS -Wno-unused-command-line-argument"
+	fi
+	# Remove clang 12+'s compound-token-split-by-macro, as this causes a lot
+	# of warnings when building plperl because of usages in the Perl headers.
+	NOT_THE_CFLAGS=""
+	PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wcompound-token-split-by-macro])
+	if test -n "$NOT_THE_CFLAGS"; then
+		CFLAGS="$CFLAGS -Wno-compound-token-split-by-macro"
+	fi
+	# Similarly disable useless truncation warnings from gcc 8+
+	NOT_THE_CFLAGS=""
+	PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wformat-truncation])
+	if test -n "$NOT_THE_CFLAGS"; then
+		CFLAGS="$CFLAGS -Wno-format-truncation"
+	fi
+	NOT_THE_CFLAGS=""
+	PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wstringop-truncation])
+	if test -n "$NOT_THE_CFLAGS"; then
+		CFLAGS="$CFLAGS -Wno-stringop-truncation"
+	fi
+	# Suppress clang 16's strict warnings about function casts
+	NOT_THE_CFLAGS=""
+	PGAC_PROG_CC_VAR_OPT(NOT_THE_CFLAGS, [-Wcast-function-type-strict])
+	if test -n "$NOT_THE_CFLAGS"; then
+		CFLAGS="$CFLAGS -Wno-cast-function-type-strict"
+	fi
 elif test "$ICC" = yes; then
-  # Intel's compiler has a bug/misoptimization in checking for
-  # division by NAN (NaN == 0), -mp1 fixes it, so add it to the CFLAGS.
-  PGAC_PROG_CC_CFLAGS_OPT([-mp1])
-  PGAC_PROG_CXX_CFLAGS_OPT([-mp1])
-  # Make sure strict aliasing is off (though this is said to be the default)
-  PGAC_PROG_CC_CFLAGS_OPT([-fno-strict-aliasing])
-  PGAC_PROG_CXX_CFLAGS_OPT([-fno-strict-aliasing])
+	# Intel's compiler has a bug/misoptimization in checking for
+	# division by NAN (NaN == 0), -mp1 fixes it, so add it to the CFLAGS.
+	PGAC_PROG_CC_CFLAGS_OPT([-mp1])
+	PGAC_PROG_CXX_CFLAGS_OPT([-mp1])
+	# Make sure strict aliasing is off (though this is said to be the default)
+	PGAC_PROG_CC_CFLAGS_OPT([-fno-strict-aliasing])
+	PGAC_PROG_CXX_CFLAGS_OPT([-fno-strict-aliasing])
 fi
 
 # If the compiler knows how to hide symbols, add the switch needed for that to
@@ -605,16 +605,16 @@ fi
 # compiler that supports one of the supported variants of -fvisibility=hidden
 # but uses a different syntax to mark a symbol as exported.
 if test "$GCC" = yes; then
-  PGAC_PROG_CC_VAR_OPT(CFLAGS_SL_MODULE, [-fvisibility=hidden])
-  # For C++ we additionally want -fvisibility-inlines-hidden
-  PGAC_PROG_VARCXX_VARFLAGS_OPT(CXX, CXXFLAGS_SL_MODULE, [-fvisibility=hidden])
-  PGAC_PROG_VARCXX_VARFLAGS_OPT(CXX, CXXFLAGS_SL_MODULE, [-fvisibility-inlines-hidden])
-  have_visibility_attribute=$pgac_cv_prog_CC_cflags__fvisibility_hidden
+	PGAC_PROG_CC_VAR_OPT(CFLAGS_SL_MODULE, [-fvisibility=hidden])
+	# For C++ we additionally want -fvisibility-inlines-hidden
+	PGAC_PROG_VARCXX_VARFLAGS_OPT(CXX, CXXFLAGS_SL_MODULE, [-fvisibility=hidden])
+	PGAC_PROG_VARCXX_VARFLAGS_OPT(CXX, CXXFLAGS_SL_MODULE, [-fvisibility-inlines-hidden])
+	have_visibility_attribute=$pgac_cv_prog_CC_cflags__fvisibility_hidden
 fi
 
 if test "$have_visibility_attribute" = "yes"; then
-  AC_DEFINE([HAVE_VISIBILITY_ATTRIBUTE], 1,
-            [Define to 1 if your compiler knows the visibility("hidden") attribute.])
+	AC_DEFINE([HAVE_VISIBILITY_ATTRIBUTE], 1,
+						[Define to 1 if your compiler knows the visibility("hidden") attribute.])
 fi
 
 AC_SUBST(CFLAGS_UNROLL_LOOPS)
